#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "abf.h"
#include "trivial.h"
#include "ku.h"
#include "timer.h"

/* ---------------- */
#define TMPTXT "/tmp/text.txt"
#define TMPPAT "/tmp/pattern.txt"

#define PATMIN 10
#define PATMAX 200
#define PATSTEP 5
#define TEXTMIN 20
#define TEXTMAX 2000
#define TEXTSTEP 10
/* ---------------- */

#include "tests.h"

int main(int argc, char *argv[]) {
	int i1,i2,i3;
	char c1;
	double abf_time_mit,abf_time_ohne,trivial_time,ku_sq_mit,ku_sq_ohne;
	FILE *datei,*tmptext,*tmppattern;

	if(argc != 3) {
		printf("Usage: %s <vorlage> <alphabetgroesse>\n",argv[0]);
		return(-1);
	}

	datei=fopen(argv[1],"r");
	if(datei == (FILE *)NULL) {
		printf("unable to open %s\n\n",argv[1]);
		return(-1);
	}

	printf("Wachsende Textgroesse max(|Sigma|)=%s\n",argv[2]);
	printf("n\t\ttrivial\t\tabf_ohne\tabf_mit\t\tku_sq_ohne\tku_sq_mit\tku_lin_ohne\tku_lin_mit\ttriv_proz\tabf_proz\tsq_proz\t\tlin_proz\n");

	for(i1=TEXTMIN; i1<TEXTMAX; i1+=TEXTSTEP) {
		rewind(datei);
		tmptext=fopen(TMPTXT,"w");
		if(tmptext == (FILE *)NULL) {
			printf("unable to open %s\n\n",TMPTXT);
			return(-1);
		}

		tmppattern=fopen(TMPPAT,"w");
		if(tmppattern == (FILE *)NULL) {
			printf("unable to open %s\n\n",TMPPAT);
			return(-1);
		}

		for(i2=0; i2<i1; i2++) {
			for(i3=0; i3<i1; i3++) {
				c1=(char)fgetc(datei);
				while(c1 == '\n' || c1 == '\r' || c1 == EOF || c1 == 0)
					c1=(char)fgetc(datei);
				fputc(c1,tmptext);
				if(i3 < PATMIN && i2 < PATMIN)
					fputc(c1,tmppattern);
			}
			fputc('\n',tmptext);
			if(i2 < PATMIN)
				fputc('\n',tmppattern);
		}
		fclose(tmppattern);
		fclose(tmptext);	

		runtests(atoi(argv[2]),i1);

	}

	printf("Wachsende Patterngroesse max(|Sigma|)=%s\n",argv[2]);
	printf("m\t\ttrivial\t\tabf_ohne\tabf_mit\t\tku_sq_ohne\tku_sq_mit\tku_lin_ohne\tku_lin_mit\ttriv_proz\tabf_proz\tsq_proz\t\tlin_proz\n");

  rewind(datei);
  tmptext=fopen(TMPTXT,"w");
  if(tmptext == (FILE *)NULL) {
    printf("unable to open %s\n\n",TMPTXT);
    return(-1);
   }

  for(i2=0; i2<TEXTMAX/4; i2++) {
    for(i3=0; i3<TEXTMAX/4; i3++) {
      c1=(char)fgetc(datei);
			while(c1 == '\n' || c1 == '\r' || c1 == EOF || c1 == 0)
				c1=(char)fgetc(datei);
      fputc(c1,tmptext);
    }
    fputc('\n',tmptext);
  }
  fclose(tmptext);

  fclose(datei);


	datei=fopen(TMPTXT,"r");
	if(datei == (FILE *)NULL) {
		printf("unable to open %s\n\n",TMPTXT);
		return(-1);
	}

	for(i1=PATMIN; i1<PATMAX; i1+=PATSTEP) {
    rewind(datei);

    tmppattern=fopen(TMPPAT,"w");
    if(tmppattern == (FILE *)NULL) {
      printf("unable to open %s\n\n",TMPPAT);
      return(-1); 
    }

    for(i2=0; i2<i1; i2++) {
      for(i3=0; i3<i1; i3++) {
        c1=(char)fgetc(datei);
				if(c1 == '\n' || c1 == '\r' || c1 == EOF || c1 == 0) {
					c1=(char)fgetc(datei);
				}
        fputc(c1,tmppattern);
      }
      fputc('\n',tmppattern);
    }
    fclose(tmppattern);

    runtests(atoi(argv[2]),i1);

  }


	fclose(datei);

	return(0);
}
